(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('primeng/dom'), require('@angular/router')) :
    typeof define === 'function' && define.amd ? define('primeng/menubar', ['exports', '@angular/core', '@angular/common', 'primeng/dom', '@angular/router'], factory) :
    (global = global || self, factory((global.primeng = global.primeng || {}, global.primeng.menubar = {}), global.ng.core, global.ng.common, global.primeng.dom, global.ng.router));
}(this, (function (exports, core, common, dom, router) { 'use strict';

    var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    };
    var MenubarSub = /** @class */ (function () {
        function MenubarSub(renderer, cd) {
            this.renderer = renderer;
            this.cd = cd;
            this.autoZIndex = true;
            this.baseZIndex = 0;
            this.menuHoverActive = false;
        }
        Object.defineProperty(MenubarSub.prototype, "parentActive", {
            get: function () {
                return this._parentActive;
            },
            set: function (value) {
                if (!this.root) {
                    this._parentActive = value;
                    if (!value)
                        this.activeItem = null;
                }
            },
            enumerable: true,
            configurable: true
        });
        MenubarSub.prototype.onItemMenuClick = function (event, item, menuitem) {
            if (!this.autoDisplay) {
                if (menuitem.disabled) {
                    return;
                }
                this.activeItem = this.activeMenu ? (this.activeMenu.isEqualNode(item) ? null : item) : item;
                var nextElement = item.children[0].nextElementSibling;
                if (nextElement) {
                    var sublist = nextElement.children[0];
                    if (this.autoZIndex) {
                        sublist.style.zIndex = String(this.baseZIndex + (++dom.DomHandler.zindex));
                    }
                    if (this.root) {
                        sublist.style.top = dom.DomHandler.getOuterHeight(item.children[0]) + 'px';
                        sublist.style.left = '0px';
                    }
                    else {
                        sublist.style.top = '0px';
                        sublist.style.left = dom.DomHandler.getOuterWidth(item.children[0]) + 'px';
                    }
                }
                this.menuClick = true;
                this.menuHoverActive = this.activeMenu ? (!this.activeMenu.isEqualNode(item)) : true;
                this.activeMenu = this.activeMenu ? (this.activeMenu.isEqualNode(item) ? null : item) : item;
                this.bindEventListener();
            }
        };
        MenubarSub.prototype.bindEventListener = function () {
            var _this = this;
            if (!this.documentClickListener) {
                this.documentClickListener = this.renderer.listen('document', 'click', function (event) {
                    if (!_this.menuClick) {
                        _this.activeItem = null;
                        _this.menuHoverActive = false;
                        _this.activeMenu = false;
                    }
                    _this.menuClick = false;
                });
            }
        };
        MenubarSub.prototype.onItemMouseEnter = function (event, item, menuitem) {
            if (this.autoDisplay || (!this.autoDisplay && this.root && this.menuHoverActive)) {
                if (menuitem.disabled) {
                    return;
                }
                if ((this.activeItem && !this.activeItem.isEqualNode(item) || !this.activeItem)) {
                    this.activeItem = item;
                    var nextElement = item.children[0].nextElementSibling;
                    if (nextElement) {
                        var sublist = nextElement.children[0];
                        sublist.style.zIndex = String(++dom.DomHandler.zindex);
                        if (this.root) {
                            sublist.style.top = dom.DomHandler.getOuterHeight(item.children[0]) + 'px';
                            sublist.style.left = '0px';
                        }
                        else {
                            sublist.style.top = '0px';
                            sublist.style.left = dom.DomHandler.getOuterWidth(item.children[0]) + 'px';
                        }
                    }
                    this.activeMenu = item;
                }
            }
        };
        MenubarSub.prototype.itemClick = function (event, item) {
            if (item.disabled) {
                event.preventDefault();
                return;
            }
            if (!item.url) {
                event.preventDefault();
            }
            if (item.command) {
                item.command({
                    originalEvent: event,
                    item: item
                });
            }
            this.activeItem = null;
        };
        MenubarSub.prototype.listClick = function (event) {
            if (this.autoDisplay) {
                this.activeItem = null;
            }
        };
        MenubarSub.prototype.ngOnDestroy = function () {
            if (this.documentClickListener) {
                this.documentClickListener();
                this.documentClickListener = null;
            }
        };
        MenubarSub.ctorParameters = function () { return [
            { type: core.Renderer2 },
            { type: core.ChangeDetectorRef }
        ]; };
        __decorate([
            core.Input()
        ], MenubarSub.prototype, "item", void 0);
        __decorate([
            core.Input()
        ], MenubarSub.prototype, "root", void 0);
        __decorate([
            core.Input()
        ], MenubarSub.prototype, "autoDisplay", void 0);
        __decorate([
            core.Input()
        ], MenubarSub.prototype, "autoZIndex", void 0);
        __decorate([
            core.Input()
        ], MenubarSub.prototype, "baseZIndex", void 0);
        __decorate([
            core.Input()
        ], MenubarSub.prototype, "parentActive", null);
        MenubarSub = __decorate([
            core.Component({
                selector: 'p-menubarSub',
                template: "\n        <ul [ngClass]=\"{'ui-menubar-root-list':root, 'ui-widget-content ui-corner-all ui-submenu-list ui-shadow':!root}\"\n            (click)=\"listClick($event)\">\n            <ng-template ngFor let-child [ngForOf]=\"(root ? item : item.items)\">\n                <li *ngIf=\"child.separator\" class=\"ui-menu-separator ui-widget-content\" [ngClass]=\"{'ui-helper-hidden': child.visible === false}\">\n                <li *ngIf=\"!child.separator\" #listItem [ngClass]=\"{'ui-menuitem ui-corner-all':true,\n                        'ui-menu-parent':child.items,'ui-menuitem-active':listItem==activeItem,'ui-helper-hidden': child.visible === false}\"\n                        (mouseenter)=\"onItemMouseEnter($event,listItem,child)\" (click)=\"onItemMenuClick($event, listItem, child)\">\n                    <a *ngIf=\"!child.routerLink\" [href]=\"child.url||'#'\" [attr.data-automationid]=\"child.automationId\" [attr.target]=\"child.target\" [attr.title]=\"child.title\" [attr.id]=\"child.id\" (click)=\"itemClick($event, child)\"\n                         [ngClass]=\"{'ui-menuitem-link ui-corner-all':true,'ui-state-disabled':child.disabled}\" [ngStyle]=\"child.style\" [class]=\"child.styleClass\" \n                         [attr.tabindex]=\"child.tabindex ? child.tabindex : '0'\" [attr.aria-haspopup]=\"item.items != null\" [attr.aria-expanded]=\"item === activeItem\">\n                        <span class=\"ui-menuitem-icon\" *ngIf=\"child.icon\" [ngClass]=\"child.icon\"></span>\n                        <span class=\"ui-menuitem-text\">{{child.label}}</span>\n                        <span class=\"ui-submenu-icon pi pi-fw\" *ngIf=\"child.items\" [ngClass]=\"{'pi-caret-down':root,'pi-caret-right':!root}\"></span>\n                    </a>\n                    <a *ngIf=\"child.routerLink\" [routerLink]=\"child.routerLink\" [attr.data-automationid]=\"child.automationId\" [queryParams]=\"child.queryParams\" [routerLinkActive]=\"'ui-state-active'\" [routerLinkActiveOptions]=\"child.routerLinkActiveOptions||{exact:false}\"\n                        [attr.target]=\"child.target\" [attr.title]=\"child.title\" [attr.id]=\"child.id\" [attr.tabindex]=\"child.tabindex ? child.tabindex : '0'\" role=\"menuitem\"\n                        (click)=\"itemClick($event, child)\" [ngClass]=\"{'ui-menuitem-link ui-corner-all':true,'ui-state-disabled':child.disabled}\" [ngStyle]=\"child.style\" [class]=\"child.styleClass\">\n                        <span class=\"ui-menuitem-icon\" *ngIf=\"child.icon\" [ngClass]=\"child.icon\"></span>\n                        <span class=\"ui-menuitem-text\">{{child.label}}</span>\n                        <span class=\"ui-submenu-icon pi pi-fw\" *ngIf=\"child.items\" [ngClass]=\"{'pi-caret-down':root,'pi-caret-right':!root}\"></span>\n                    </a>\n                    <p-menubarSub class=\"ui-submenu\" [parentActive]=\"listItem==activeItem\" [item]=\"child\" *ngIf=\"child.items\" [autoDisplay]=\"true\"></p-menubarSub>\n                </li>\n            </ng-template>\n        </ul>\n    "
            })
        ], MenubarSub);
        return MenubarSub;
    }());
    var Menubar = /** @class */ (function () {
        function Menubar(el, renderer) {
            this.el = el;
            this.renderer = renderer;
            this.autoZIndex = true;
            this.baseZIndex = 0;
        }
        Object.defineProperty(Menubar.prototype, "autoDisplay", {
            get: function () {
                return this._autoDisplay;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Menubar.prototype, "utc", {
            set: function (_utc) {
                console.log("AutoDisplay property is deprecated and functionality is not available.");
            },
            enumerable: true,
            configurable: true
        });
        Menubar.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer2 }
        ]; };
        __decorate([
            core.Input()
        ], Menubar.prototype, "model", void 0);
        __decorate([
            core.Input()
        ], Menubar.prototype, "style", void 0);
        __decorate([
            core.Input()
        ], Menubar.prototype, "styleClass", void 0);
        __decorate([
            core.Input()
        ], Menubar.prototype, "autoZIndex", void 0);
        __decorate([
            core.Input()
        ], Menubar.prototype, "baseZIndex", void 0);
        __decorate([
            core.Input()
        ], Menubar.prototype, "autoDisplay", null);
        Menubar = __decorate([
            core.Component({
                selector: 'p-menubar',
                template: "\n        <div [ngClass]=\"{'ui-menubar ui-widget ui-widget-content ui-corner-all':true}\" [class]=\"styleClass\" [ngStyle]=\"style\">\n            <p-menubarSub [item]=\"model\" root=\"root\" [baseZIndex]=\"baseZIndex\" [autoZIndex]=\"autoZIndex\">\n                <ng-content></ng-content>\n            </p-menubarSub>\n            <div class=\"ui-menubar-custom\">\n                <ng-content></ng-content>\n            </div>\n        </div>\n    "
            })
        ], Menubar);
        return Menubar;
    }());
    var MenubarModule = /** @class */ (function () {
        function MenubarModule() {
        }
        MenubarModule = __decorate([
            core.NgModule({
                imports: [common.CommonModule, router.RouterModule],
                exports: [Menubar, router.RouterModule],
                declarations: [Menubar, MenubarSub]
            })
        ], MenubarModule);
        return MenubarModule;
    }());

    exports.Menubar = Menubar;
    exports.MenubarModule = MenubarModule;
    exports.MenubarSub = MenubarSub;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=primeng-menubar.umd.js.map
